(* File: Automata-Lib/label.sml 
   Date: 10.2.2000
*)

signature LABEL = 
    sig 
        eqtype label 
        (* type of labels for graphs, automata etc. *)
        val toString : label -> string 
	(* returns the printname of the label *)
    end


structure CharLabels : LABEL = 
    struct 
        type label = char 
        val toString = Char.toString 
    end

structure IntLabels : LABEL = 
    struct 
        type label = int
        val toString = Int.toString 
    end

structure StringLabels : LABEL =
    struct
        type label = string
        fun toString (a:label) = a
    end

structure BoolLabels : LABEL =
    struct
        type label = bool
        val toString = Bool.toString
    end

