(* Polymorphic Kleenean Algebras                             H.Leiss, 20.1.99 *)

signature pKA =
    sig 
	type 'a t
	val unit : 'a t
	val zero : 'a t
	val sum  : ''a t * ''a t -> ''a t
	val prod : ''a t * ''a t -> ''a t
	val star : ''a t -> ''a t
    end

(* Approximatively the free Kleenean algebra of regular expressions *)

structure Reg : pKA =
    struct
	type 'a t     = 'a RegExp.re
	val zero      = RegExp.Plus [] 
	val unit      = RegExp.Times[]
	fun sum(x,y)  = RegExp.nf (RegExp.Plus [x,y])
	fun prod(x,y) = RegExp.nf (RegExp.Times[x,y])
	fun star x    = RegExp.nf (RegExp.Star x)
    end

