(* File:    pptransducer.sml
   Content: Transducer with graphical represenation using AT&T's dot 
   Author:  H.Leiss, leiss@cis.uni-muenchen.de
   Date:    26.02.00
*) 

signature PPTRANSDUCER =
  sig
    include TRANSDUCER
    eqtype labelIn
    type labelOut
    val display : (labelIn,labelOut) transducer -> string -> OS.Process.status
  end

functor ppTransducer(structure In : LABEL; structure Out : LABEL) : PPTRANSDUCER = 
  struct
    open Transducer 
    type labelIn = In.label
    type labelOut = Out.label

    structure M = ppFm(struct 
                         type label = In.label * Out.label
                         fun toString (a,b) = 
                           "\"" ^ In.toString a ^ " / " ^ Out.toString b ^ "\""
                       end)
    val display = M.display
  end 


(* Example 1:

structure TdIB = ppTransducer(structure In = IntLabels 
                              structure Out = BoolLabels)

val T = TdIB.make{start = [0], final = [2],
                  trans = [(0,(0,false),0),(0,(1,true),1),(1,(1,false),1),
                           (1,(0,true),1),(1,(0,false),2)]}

TdIB.display T "file";

TdIB.translate T [0,1,1,0,0,0]

*)





