(* File:    regexp_weak.sig 
   Content: Restricted signature for regular expressions, omitting 
            freeVars,subst,substExp,varNum,maxVar of regexp.sig
   Date:    12/99
   Author:  H.Leiss
   Status:  preliminary 
*)

signature REGEXP_WEAK =
  sig
    datatype 'a re
      = Atom of 'a
      | Plus of 'a re list
      | Star of 'a re
      | Times of 'a re list
      | Var of int

    val Unit   : 'a re
    val Zero   : 'a re
    val It     : 'a re -> 'a re
    val Power  : 'a re -> int -> 'a re
    val Powers : 'a re -> int -> 'a re

    exception Undefined

    val subst : (int * 'a re) list -> 'a re -> 'a re

    val nf : ''a re -> ''a re
    val dnf : ''a re -> ''a re

    val factorizel : ''a re -> ''a re
    val factorizer : ''a re -> ''a re
  end

