(* File:    regexpfm.sml 
   Content: Translations from regular expressions to finite automata and conversely.
            Intended
   Date:    12/99
   Author:  H.Leiss

   Edited:
   12.02.00 moved RegEqnsFm to a new file, for .mldoc
   01.03.00 moved examples to ppregexpfm.sml
*)

signature REGEXPFM =
    sig
	structure E : REGEQNS (* not just expressions! *)
	structure M : FM 

	type ''a machine = ''a M.machine
        datatype re = datatype E.re

	val accept : ''a machine -> ''a list -> bool
	val retofm : ''a re -> ''a machine
	val retominfm : ''a re -> ''a machine
        val fmtore : ''a machine -> ''a re
    end 

structure RegExpFm : REGEXPFM = RegEqnsFm :> REGEXPFM

