(* Matrixalgebra over a polymorphic Kleenean Algebra         H.Leiss, 20.1.99 *)

structure RegMat : 
    sig
	structure Ring : pKA
	type 'a t                            (* matrices over Ring *)
	val dimension : 'a t -> int * int
	val tabulate : (int * int) -> (int * int -> 'a Ring.t) -> 'a t
	val sub : 'a t * (int * int) -> 'a Ring.t
	val map : ('a Ring.t -> 'a Ring.t) -> 'a t -> 'a t

	val zero : int * int -> 'a t
	val unit : int * int -> 'a t
	val sum  : ''a t * ''a t -> ''a t
	val prod : ''a t * ''a t -> ''a t
	val star : ''a t -> ''a t
	val transpose : ''a t -> ''a t
    end = pkaMatrix(Reg) 



