(* Extracted from Develop-Lib/grammar.sml          14.2.2000 *)

signature REGMOD =
    sig
         structure K : KA
         structure Exp : REGEXP
         datatype re  = datatype Exp.re
         eqtype alph  
         type exp     = alph re
         type t = K.t

         val eval : (int -> t) -> exp -> t
    end

functor RegMod (structure K : KA; eqtype alph; val envAtom : alph -> K.t) : REGMOD =
    struct
        structure K = K : KA
        structure Exp = RegExp : REGEXP
        type alph  = alph
	val envAtom  = envAtom

	datatype re = datatype Exp.re
        type exp = alph Exp.re
        type t = K.t

	fun eval env (Var i) = env i
	  | eval env (Atom a) = envAtom a
	  | eval env (Plus es) = 
	    List.foldr (fn (e,a) => K.sum(eval env e,a)) K.zero es
	  | eval env (Times es) =
	    List.foldr (fn (e,a) => K.prod(eval env e,a)) K.unit es
	  | eval env (Star e) = K.star (eval env e)
    end 

